# TP2 - Intégration en continue: Automatisation de la gestion du build et des dépendances et des tests.

## Laboratoire

À partir du code du laboratoire #1 nous allons ajouter une intégration de la
gestion des dépendances, l'exécution automatisé des tests et de la construction
automatique du logiciel dans Travis-CI.


### Tâches

- Mise en route de l'intégration en continue avec [Travis-ci](https://travis-ci.com/glo2003).
    Il y a plusieurs [exemples](https://github.com/travis-ci/travis.rb) sur Github
- Utiliser [Travis-ci.com][travis], comme nos répertoires `git` sont privés nous
    devons utiliser Travis-CI privé.
- Ajouter des tests.
- Ajouter l'exécution des tests unitaires automatiques.
- Ajouter des fonctionnalités au logiciel. Des "issues" Github seront créés dans
    vos projets.
- Le projet doit être fonctionnel
- Les requis du laboratoire précédent doivent encore être opérationnels
- Documenter votre processus d'intégration continue, y mettre 4 références et
   résumer chacune d'elle
- Documenter votre processus de développement logiciel à l'aide d'un schéma (fait avec process edit par exemple). Plus de détails dans le issues.

## Remise

- Répertoire git dans github avec `tag` `remise-2` positionné sur le bon commit,
    le tag doit avoir été créé et synchronisé avant la date limite.
- Avoir les issues terminés.
    aussi sont fermées).
- Avoir travis-ci fonctionnel avec les tests unitaires et la construction du
    logiciel automatique fonctionnel.
- Réponses aux questions et documentation demandées dans les issues

## Évaluation

Le laboratoire vaut 8% de la session, les notes seront distribuées comme suit:

- 50% Projet
  - Nouvelles fonctionnalitées
  - Utilisation de Git
- 50% Wiki

ps. Vous êtes évalués autant sur ce que vous livrez que sur la pratique et la façon
d'y arriver.

## Références

- [Continuous integration - Martin Fowler](http://www.martinfowler.com/articles/continuousIntegration.html)
- [Documentation de Travis-ci](https://docs.travis-ci.com/)
- [Exemple](https://github.com/glo2003/project-dashboard-frontend)

[travis]:https://travis-ci.com/
