# TP4 - Sprint, agilité

## Laboratoire

Ce laboratoire consiste à utiliser un processus de développement logiciel de type
Scrum afin d'améliorer le projet de session. Les outils précédemment appris et
configurés au cours des précédents laboratoires (travis, github, git, maven/gradle/go, ...)
serviront à vous supporter au cours de ce laboratoire.


### Code
- Résolvez 2 Users stories (provenant du laboratoire précédent)

- Écrivez un test d'acceptation pour une des stories implémentée (au labo 3 ou labo 4)

> *NOTE* Validez avec l'auxiliaire de laboratoire les user stories que vous voulez implémenter pour confirmer si les stories ont une complexité adéquate.

> *NOTE* Le test d'acceptation doit être end-to-end. L'utilisation d'outils spécifiquement conçus pour les tests d'acceptation (ex. Cucumber) est encouragée mais non requise. Précision 7 avril: Même si vous n'utilisez pas Cucumber, **votre test doit être automatisé dans Travis** (avec ex. JUnit).


## Tableaux agiles

Créez un ou des tableaux pour organiser les issues github. Pour ceux qui n'utilisent pas déjà un autre outil, il est conseillé d'utiliser la fonctionnalité intégrée
directement à Github (voir https://help.github.com/articles/creating-a-project-board/). Pour les autres qui utilisent déjà Trello, Waffle.io ou autre, vous pouvez
continuer sur ces outils mais assurez vous que l'auxiliaire a accès **avant la remise**.


Vous être libre d'utiliser la méthodologie que vous voulez pour travailler avec ce ou ces tableaux (il peut en avoir un ou plusieurs selon votre méthodologie).
Vous devrez répondre à ces questions dans un wiki `Labo 4`.

1. Utilisez-vous un ou plusieurs tableau? Quel est le rôle de chaque tableau?
2. Énumérez les colonnes des tableaux et décrivez leurs rôles en quelques mots.
3. Selon vous, est-ce que votre façon de travailler avec les tableaux ressemble plus à Scrum ou Kanban? Justifiez, en donnant deux (2) sources pertinentes.


### Rétrospective sur votre processus de développement

Dans le wiki `Labo 4`, répondez aux questions suivantes. La qualité de réflexion est évaluée. Une équipe qui fait des bons liens entre sa façon de travailler et l'agilité et
une autre qui expose bien ses lacune au niveau de l'agilité auront toutes deux tous les points.

1. Quelle est la qualité de votre travail final? Reste-t-il une dette technique?

2. Quelle bonne façon de travailler a été mise en place par l’équipe et que les coéquipiers voudraient continuer à utiliser à l’avenir? Quels ont été les bons coups?
Y a-t-il eu des obstacles au travail d’équipe? Y a-t-il des compétences en génie logiciel ou des connaissances sur les outils ou les processus à aller chercher?

3. Quels canaux de communications vous ont été le plus utile lors du projet (Trello, courriel, issues Github, rencontres en personne, etc.)? Faites un lien
entre vos façons de communiquer et l'agilité.

4. Identifiez deux problèmes au niveau de processus et trouvez un solution ou un plan d'action à mettre en place pour y pallier.

5. Pourriez-vous travailler exactement de la même manière pour un projet d'une équipe de 10 personnes? Qu'est-ce qui fonctionnerait aussi bien? Qu'est-ce qui serait à améliorer?

### Évaluation de l'équipe

Avec le formulaire d'évaluation d'équipe sur le portail ENA, à la fin du projet.

### Évaluation du projet de session

Donnez-moi une évaluation et des commentaires sur le projet de session dans le wiki.

- Ce qui pourrait être amélioré
- Les outils que vous auriez aimé connaître
- ...

Ces commentaires seront utiles pour l'élaboration du projet l'an prochain. Des points sont accordés à la présence de cette évaluation.

## Remise

- Lien vers votre (vos) tableau(x) de style Scrum ou Kanban dans le wiki (Github Projects, Trello, Waffle.io, etc.)
- Code dans git, avec un `tag` `remise-4` positionné sur le bon commit
- **Le tp sera corrigé sur Heroku**. Vous devrez donc le déployer comme au TP3
- Évaluation des membres de l'équipe
- Rétrospective de projet et réflexion
- Évaluation du laboratoire
- Le projet doit être fonctionnel
- Les requis des laboratoires précédents doivent encore être opérationnels


## Évaluation

Le laboratoire vaut 8% de la session.


## Références

- [Github Projects](https://help.github.com/articles/creating-a-project-board/)
- [Agile Manifesto](http://www.agilemanifesto.org/)
